#include "Bit_TYPE.h"
#include "Bit_TYPE_Ops.h"

void
#ifdef _BT_ANSIC
MSK_BTS( int *s, int m, int n )
#else
MSK_BTS( s, m, n )
int *s, m, n;
#endif
{
	int i,v;
	i = n-m+1;
	v = 0;
	while( i>0 ){
		v = 2*v+1;
		i = i-1;
	};
	*(s) = v<<(32-n);
}


void
#ifdef _BT_ANSIC
VMS_BTS( int *s, int b, int m, int n )
#else
VMS_BTS( s, b, m, n )
int *s, b, m, n;
#endif
{
	int i,v;
	i = n-m+1;
	v = 0;
	while( i>0 ){
		v = 2*v+1;
		i = i-1;
	};
	*(s) = ((b&(v<<(32-n)))>>(32-n));
}


void
#ifdef _BT_ANSIC
MMS_BTS( int *s, int b, int m, int n, int w )
#else
MMS_BTS( s, b, m, n, w )
int *s, b, m, n, w;
#endif
{
	int i,v;
	i = n-m+1;
	v = 0;
	while( i>0 ){
		v = 2*v+1;
		i = i-1;
	};
	*(s) = (~(v<<(32-n))&b)|((w&v)<<(32-n));
}


void
#ifdef _BT_ANSIC
VAL_BTS( int *s, int b, int n)
#else
VAL_BTS( s, b, n)
int *s, b, n;
#endif
{
	VMS_BTS(s,b,n,n);
}


void
#ifdef _BT_ANSIC
STO_BTS( int *s, int b, int n, int w )
#else
STO_BTS( s, b, n, w )
int *s, b, n;
#endif
{
	MMS_BTS(s,b,n,n,w);
}

