#include "Rename_Bit_String.h"


void
#ifdef _BT_ANSIC
Rename_VMS_BTS( int *s, int b, int m, int n )
#else
Rename_VMS_BTS( s, b, m, n )
int *s, b, m, n;
#endif
{
	int i,v;
	i = n-m+1;
	v = 0;
	while( i>0 ){
		v = 2*v+1;
		i = i-1;
	};
	*(s) = ((b&(v<<(32-n)))>>(32-n));
}


void
#ifdef _BT_ANSIC
Rename_MMS_BTS( int *s, int b, int m, int n, int w )
#else
Rename_MMS_BTS( s, b, m, n, w )
int *s, b, m, n, w;
#endif
{
	int i,v;
	i = n-m+1;
	v = 0;
	while( i>0 ){
		v = 2*v+1;
		i = i-1;
	};
	*(s) = (~(v<<(32-n))&b)|((w&v)<<(32-n));
}



void
#ifdef _BT_ANSIC
Rename_VAL_BTS( int *s, int b, int n)
#else
Rename_VAL_BTS( s, b, n)
int *s, b, n;
#endif
{
	Rename_VMS_BTS(s,b,n,n);
}

void
#ifdef _BT_ANSIC
Rename_STO_BTS( int *s, int b, int n, int w )
#else
Rename_STO_BTS( s, b, n, w )
int *s, b, n;
#endif
{
	Rename_MMS_BTS(s,b,n,n,w);
}

