#include "Rename_Timer.h"
#include "Bool_TYPE.h"
#include "Scalar_TYPE.h"

#define __inc_month \
  { \
    _dd = 1; \
    _mm++; \
    if ( _mm == 13 ) { _mm = 1; _yy++; } \
  }

void
Rename_IncYearMonthDay( int * _inc_ymd, int _ymd, int _days )
{
  int _loop_n    = _days;
  int _dd        = _ymd-100*(_ymd/100);
  int _mm        = (_ymd/100)-100*(_ymd/10000);
  int _yy        = _ymd/10000;
  while ( _loop_n ) {
    switch ( _dd ) {
    case 31:
      __inc_month;
      break;
    case 30:
      switch ( _mm ) {
      case  9:
      case  4:
      case  6:
      case 11:
        __inc_month;
        break;
      default :
        _dd++;
        break;
      }
      break;
    case 29:
      switch ( _mm ) {
      case  2:
        __inc_month;
        break;
      default :
        _dd++;
        break;
      }
      break;
    case 28:
      switch ( _mm ) {
      case  2:
        if ( _yy == _yy-4*(_yy/4) ) _dd++;
        else  __inc_month;
        break;
      default :
        _dd++;
        break;
      }
      break;
    default:
      _dd++;
      break;
    }
    _loop_n--;
  }
  * _inc_ymd = (_yy*10000)+(_mm*100)+_dd;
}
