#include <sys/types.h>
#include <time.h>

extern time_t Rename_sto;
extern time_t Rename_exp;


#define INI_Rename_Timer()      { Rename_exp = 0; Rename_sto = 0; }

#define Rename_GetCurTime(t)    { * t = time ( NULL ); }

#define Rename_StoTime(t)       { Rename_sto = t; }

#define Rename_GetStoTime(t)    { * t = Rename_sto; }

#define Rename_StartTimer(e,i)  { Rename_exp = time ( NULL ) + i; * e = Rename_exp; }

#define Rename_CheckTimer(e)    { * e = ( ( Rename_exp <= time ( NULL ) ) != 0 ); }

#define Rename_GetCurYearMonthDay(n) \
{ \
  struct tm* tm_struct; \
  time_t t = time ( NULL ); \
  tm_struct = localtime ( & t ); \
  * n = ( ( tm_struct -> tm_year + 1900 ) * 10000 ) + \
        ( ( tm_struct -> tm_mon  +    1 ) * 100   ) + \
        ( ( tm_struct -> tm_mday        )         ); \
}

void Rename_IncYearMonthDay();
