#include "Rename_Varr.h"

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>

extern FILE *dump_file;

#define convert_arr_htonl(a,i,n) \
  j = i; \
  k = 0; \
  while ( k < n ) { \
    a [ j ] = htonl ( a [ j ] ); \
    j++; \
    k++; \
  }

#define convert_arr_ntohl(a,i,n) \
  j = i; \
  k = 0; \
  while ( k < n ) { \
    a [ j ] = ntohl ( a [ j ] ); \
    j++; \
    k++; \
  }

#define  write_fm(a,b)    fwrite(&a,sizeof(int),b,dump_file)

void
Rename_SAV_ARR()
{
	write_fm(Rename_Varray[1],Rename_VarrP2);
}

void
Rename_SAVN_ARR()
{
        int j, k;
	convert_arr_htonl(Rename_Varray,1,Rename_VarrP2);
	write_fm(Rename_Varray[1],Rename_VarrP2);
	convert_arr_ntohl(Rename_Varray,1,Rename_VarrP2);
}


#define  read_fm(a,b)    fread(&a,sizeof(int),b,dump_file)

void
Rename_RST_ARR()
{
	read_fm(Rename_Varray[1],Rename_VarrP2);
}

void
Rename_RSTN_ARR()
{
        int j, k;
	read_fm(Rename_Varray[1],Rename_VarrP2);
	convert_arr_ntohl(Rename_Varray,1,Rename_VarrP2);
}


void
#ifdef _BT_ANSIC
Rename_SWP_ARR( int ii, int jj )
#else
Rename_SWP_ARR( ii, jj )
int ii, jj;
#endif
{
	int i;
	i=Rename_Varray[ii];
	Rename_Varray[ii]=Rename_Varray[jj];
	Rename_Varray[jj]=i;
}


void
#ifdef _BT_ANSIC
Rename_SCH_LO_EQL_ARR( int *bb, int *ii, int jj, int kk, int vv )
#else
Rename_SCH_LO_EQL_ARR( bb, ii, jj, kk, vv )
int *bb;
int *ii;
int jj, kk, vv;
#endif
{
	int r,y;
	r=jj;
	y=kk+1;
	while( y!=r ){
		if( Rename_Varray[r] == vv ){
			y=r;
		} else{
			r=r+1;
		};
	}
	*(bb)=((r!=kk+1)!=0);
	*(ii)=r;
}


void
#ifdef _BT_ANSIC
Rename_SCH_LO_NEQ_ARR( int *bb, int *ii, int jj, int kk, int vv )
#else
Rename_SCH_LO_NEQ_ARR( bb, ii, jj, kk, vv )
int *bb;
int *ii;
int jj, kk, vv;
#endif
{
	int r,y;
	r=jj;
	y=kk+1;
	while( y!=r ){
		if( Rename_Varray[r] != vv ){
			y=r;
		} else{
			r=r+1;
		};
	}
	*(bb)=((r!=kk+1)!=0);
	*(ii)=r;
}


void
#ifdef _BT_ANSIC
Rename_SCH_HI_EQL_ARR( int *bb, int *ii, int jj, int kk, int vv )
#else
Rename_SCH_HI_EQL_ARR( bb, ii, jj, kk, vv )
int *bb;
int *ii;
int jj, kk, vv;
#endif
{
	int r,y;
	r=kk;
	y=jj-1;
	while( y!=r ){
		if( Rename_Varray[r] == vv ){
			y=r;
		} else{
			r=r-1;
		};
	}
	*(bb)=((r!=jj-1)!=0);
	*(ii)=r;
}


void
#ifdef _BT_ANSIC
Rename_SCH_HI_NEQ_ARR( int *bb, int *ii, int jj, int kk, int vv )
#else
Rename_SCH_HI_NEQ_ARR( bb, ii, jj, kk, vv )
int *bb;
int *ii;
int jj, kk, vv;
#endif
{
	int r,y;
	r=kk;
	y=jj-1;
	while( y!=r ){
		if( Rename_Varray[r] != vv ){
			y=r;
		} else{
			r=r-1;
		};
	}
	*(bb)=((r!=jj-1)!=0);
	*(ii)=r;
}


void
#ifdef _BT_ANSIC
Rename_REV_ARR( int ii, int jj )
#else
Rename_REV_ARR( ii, jj )
int ii, jj;
#endif
{
	int i,j;
	i=ii;
	j=jj;
	while( i<j ){
		Rename_SWP_ARR(i,j);
		i=i+1;
		j=j-1;
	};
}


void
#ifdef _BT_ANSIC
Rename_RHT_ARR( int ii, int jj, int nn )
#else
Rename_RHT_ARR( ii, jj, nn )
int ii, jj, nn;
#endif
{
	int k,n;
	n=jj-ii+1;
	k=0;
	while( k<n ){
		if( jj+nn-k<=Rename_VarrP2 ){
			Rename_Varray[jj+nn-k]=Rename_Varray[jj-k];
		}
		k=k+1;
	};
}


void
#ifdef _BT_ANSIC
Rename_LFT_ARR( int ii, int jj, int nn )
#else
Rename_LFT_ARR( ii, jj, nn )
int ii, jj, nn;
#endif
{
	int k,n;
	n=jj-ii+1;
	k=0;
	while( k<n ){
		if( ii-nn+k>=1 ){
			Rename_Varray[ii-nn+k]=Rename_Varray[ii+k];
		}
		k=k+1;
	};
}

