#include "Rename_set.h"

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>

extern FILE *dump_file;

#define convert_arr_htonl(a,i,n) \
  j = i; \
  k = 0; \
  while ( k < n ) { \
    a [ j ] = htonl ( a [ j ] ); \
    j++; \
    k++; \
  }

#define convert_arr_ntohl(a,i,n) \
  j = i; \
  k = 0; \
  while ( k < n ) { \
    a [ j ] = ntohl ( a [ j ] ); \
    j++; \
    k++; \
  }

#define  write_fm(a,b)    fwrite(&a,sizeof(int),b,dump_file)

void
Rename_SAV_SET()
{
	write_fm(Rename_scrd,1);
	write_fm(Rename_sset[1],Rename_scrd);
}

void
Rename_SAVN_SET()
{
        int j, k;
	Rename_scrd = htonl ( Rename_scrd );
	write_fm(Rename_scrd,1);
	Rename_scrd = ntohl ( Rename_scrd );

	convert_arr_htonl(Rename_sset,1,Rename_scrd);
	write_fm(Rename_sset[1],Rename_scrd);
	convert_arr_ntohl(Rename_sset,1,Rename_scrd);
}


#define  read_fm(a,b)    fread(&a,sizeof(int),b,dump_file)

void
Rename_RST_SET()
{
	read_fm(Rename_scrd,1);
	read_fm(Rename_sset[1],Rename_scrd);
}

void
Rename_RSTN_SET()
{
        int j, k;
	read_fm(Rename_scrd,1);
	Rename_scrd = ntohl ( Rename_scrd );

	read_fm(Rename_sset[1],Rename_scrd);
	convert_arr_ntohl(Rename_sset,1,Rename_scrd);
}


void
#ifdef _BT_ANSIC
Rename_ENT_SET( int vv )
#else
Rename_ENT_SET( vv )
int vv;
#endif
{
	int i,j;
	i = 0;
	j = Rename_scrd;
	while( j!=i ){
		if( Rename_sset[j] == vv ){
			i = j;
		} else{
			j = j-1;
		};
	};
	if( j==0 ){
		Rename_sset[Rename_scrd+1] = vv;
		Rename_scrd = Rename_scrd+1;
	};
}


void
#ifdef _BT_ANSIC
Rename_RMV_SET( int vv )
#else
Rename_RMV_SET( vv )
int vv;
#endif
{
	int i,j;
	i = 0;
	j = Rename_scrd;
	while( j!=i ){
		if( Rename_sset[j] == vv ){
			i = j;
		} else{
			j = j-1;
		};
	};
	if( j!=0 ){
		Rename_sset[j] = Rename_sset[Rename_scrd];
		Rename_scrd = Rename_scrd-1;
	};
}


void
#ifdef _BT_ANSIC
Rename_MBR_SET( int *bb, int vv )
#else
Rename_MBR_SET( bb, vv )
int *bb;
int vv;
#endif
{
	int i,j;
	i = 0;
	j = Rename_scrd;
	while( j!=i ){
		if( Rename_sset[j] == vv ){
			i = j;
		} else{
			j = j-1;
		};
	};
	*bb = ((j != 0)!=0 );
}

