#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <sys/signal.h>
#include <sys/socket.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/utsname.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <netdb.h>
#include <syslog.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <errno.h>

#ifndef INADDR_NONE
#define INADDR_NONE  0xffffffff
#endif /* INADDR_NONE */

extern char * Rename_SocketClientP1[];
extern int Rename_SocketClientP2;
extern int Rename_SocketClientP3;

extern char * _out_buf;
extern int _out_buf_size;
extern int _out_buf_ptr;

extern char * _in_buf;
extern int _in_buf_size;
extern int _in_buf_ptr;
extern int _in_buf_len;


#define INI_Rename_SocketClient()   { _out_buf_ptr = 4; _in_buf_ptr = 4; }

void Rename_INIT ( int * _rep, void * _ipaddress, int _port );
void Rename_CONNECT ( int * _rep );
void Rename_WRITE ( int * _rep );
void Rename_READ ( int * _rep, int * _pp );
void Rename_CLOSE ( int * _rep );
void Rename_GET_TOK ( int * _tok, int _toksize );
void Rename_GET_STR ( int * _ss );
void Rename_GET_FIL ( int * _rep, int * _filesize, int * _filename );
void Rename_PUT_TOK ( int _tok, int _toksize );
void Rename_PUT_STR ( int * _ss );
void Rename_GET_IN_PTR ( int * _ptr );
void Rename_SET_IN_PTR ( int _ptr );
void Rename_GET_OUT_PTR ( int * _ptr );
void Rename_GET_OUT_SIZE ( int * _sz );
void Rename_SET_OUT_PTR ( int _ptr );
